# Remote Config

Remote Config is a feature that allows you to replace values or properties managed in your application with parameter values defined in the Hackle Dashboard, enabling real-time control of application behavior and configuration.

Navigate to the Remote Config screen in the Hackle Dashboard to configure parameter information and set values based on user identification rules.

## remoteConfig

Calling the `remote_config()` method returns a `HackleRemoteConfig` instance that holds the Remote Config information for the user (configured parameters and rule information).\
`remote_config()` can receive User Identifier information to match user properties against Remote Config rule information.\
You can access the desired parameter and receive its value through the methods provided by `HackleRemoteConfig`.

```python
from hackle.model import HackleUser

# 원격 구성 정보 담은 인스턴스를 반환합니다.

user = HackleUser.builder() \
                 .device_id('ae2182e0') \
                 .build()

remote_config = hackle_client.remote_config(user=user)
```

## Remote Config Parameter Lookup

* The `HackleRemoteConfig` returned by the `remote_config()` method provides a `get()` method for looking up parameter values.
* Since parameter values configured on the Hackle Remote Config screen exist as key-value pairs, you can use the methods below according to the configured parameter type to receive the configured parameter value.

{% hint style="warning" %}
Remove Remote Config-related code after archiving.

Once a Remote Config parameter is archived, you can no longer access the parameter information. Therefore, after archiving a Remote Config parameter, be sure to clean up any related code.
{% endhint %}

```python
from hackle.model import HackleUser

# 원격 구성 정보 담은 인스턴스를 반환합니다.

user = HackleUser.builder() \
                 .device_id('ae2182e0') \
                 .build()

remote_config = hackle_client.remote_config(user=user)

# string 유형의 parameter값 예제
parameterValue = remote_config.get(key='parameter_key', default='default_value')
```

* The `parameterKey` of the `get()` method is the key configured in the Remote Config parameter settings.
* `defaultValue` is the value returned when the Remote Config value cannot be determined. The entered `defaultValue` may be returned in the following situations:
  * A. A value of a different type than the type set on the Remote Config screen is provided
  * B. An unconfigured parameter key is called
  * C. Hackle SDK initialization failure
  * D. Invalid identifier information is provided or does not exist
  * E. ETC
* To receive the configured information correctly, you must enter a value of the type that matches the parameter type you configured in `defaultValue`.
* The Remote Config parameter types provided by the SDK are string, number, and boolean. The JSON type configured on the Remote Config parameter screen can be received as a string. The default value for JSON type must be entered as a string type.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hackle.io/en/development-guide/python/python-remote-config.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
